public class A4OddEvenMerge {
  public static int[] sort(int[] vals) {
    final int[] result = new int[vals.length];
    A4Node merger = null;

    switch (vals.length) {
      case 1: 
        result[0] = vals[0];
        //FALLTHROUGH
      case 0:
        return result;
      case 2:
        merger = new A4Comparator();
        break;
      default:
        merger = new A4Merger(vals.length >> 1);
    }

    A4Consumer resultConsumer = new A4Consumer() {
      public void setInputValue(int inputIndex, int value) {
        System.out.println("Result at index "+inputIndex+" is "+value);
        result[inputIndex] = value;
      }
    };

    for (int i = 0; i < result.length; i++)
      merger.setOutputConnection(i, resultConsumer, i);
    
    for (int i = 0; i < vals.length; i++)
      merger.setInputValue(i, vals[i]);
    
    return result; //early
  }

  public static void main(String[] bla) {
    int[] vals = new int[] {1, 2, 7, 8, 3, 4, 5, s6};
    //int[] vals = new int[] {3, 4, 1, 2};
    sort(vals);
  }
}